<?php
namespace MascotCoreEcoifeWP\Widgets\WPCF\Skins;
use Elementor\Widget_Base;
use Elementor\Controls_Manager;
use Elementor\Group_Control_Image_Size;
use Elementor\Skin_Base as Elementor_Skin_Base;

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class Skin_Listing_Style_Current_Theme1 extends Elementor_Skin_Base {

	protected function _register_controls_actions() {
		//add_action( 'elementor/element/tm-ele-wpcf-listing/general/after_section_end', [ $this, 'register_layout_controls' ] );
	}

	public function get_id() {
		return 'skin-listing-style-current-theme1';
	}


	public function get_title() {
		return __( 'Give Forms Style Current Theme1', 'mascot-core-ecoife-wp' );
	}


	public function register_layout_controls( Widget_Base $widget ) {
		$this->parent = $widget;
	}

	public function calculate_total_earnings($settings, $form_id) {
		$total_earnings = 0;
		if( 'yes' === $this->parent->get_instance_value_skin( 'custom_total_raised' ) ) {
			$total_earnings = $this->parent->get_instance_value_skin( 'percent' );
		} else if(isset($form_id) && !empty($form_id)) {
			//get income from form id
			$form = new \Give_Donate_Form( $form_id );
			$goal_progress_stats = give_goal_progress_stats( $form );
			$total_earnings = $goal_progress_stats['progress'];
		}
		return $total_earnings;
	}

	public function pie_chart_box_css( $settings ) {
		$css_array = array();

		if( $this->parent->get_instance_value_skin( 'size' ) != '' ) {
			$css_array[] = 'width: '.mascot_core_if_numeric_add_suffix($this->parent->get_instance_value_skin( 'size' ), 'px');
			$css_array[] = 'height: '.mascot_core_if_numeric_add_suffix($this->parent->get_instance_value_skin( 'size' ), 'px');
			$css_array[] = 'line-height: '.mascot_core_if_numeric_add_suffix($this->parent->get_instance_value_skin( 'size' ), 'px');
		}
		return implode( '; ', $css_array );
	}
	
	public function render() {
		$settings = $this->parent->get_settings_for_display();
		$settings['thisobj'] = $this;
		$settings['thisparent'] = $this->parent;
		
		$class_instance =  array();

		$settings['holder_id'] = mascot_core_get_isotope_holder_ID('wpcf-listing');

		$this->render_output( $class_instance, $settings );
	}

	public function render_output( $class_instance, $settings ) {
		$new_cpt_class = $class_instance;

		if( $settings['display_type'] != 'masonry' ) {
			$settings['use_masonry_tiles_featured_image_size'] = 'false';
		}
		
		
		$settings['the_query'] = $this->parent->query_posts();
		
		if ( !$settings['the_query']->have_posts() && isset( $settings['from_loadmore_ajax_handler'] ) && $settings['from_loadmore_ajax_handler'] === true ) {
			return;
		}
		
		//classes
		$classes = array();
		if( isset($settings['_skin']) ) {
			$classes[] = 'wpcf-listing-' . $settings['_skin'];
		}
		$classes[] = $settings['custom_css_class'];
		$settings['classes'] = $classes;

		//button classes
		$settings['btn_classes'] = mascot_core_prepare_button_classes_from_params( $settings );

		//meta options
		if(!empty($settings['meta_options'])) {
			$settings['meta_options'] = implode(",", $settings['meta_options']);
			$settings['meta_options'] = explode(',', $settings['meta_options']);
		}
		
		//Owl Carousel Data
		$settings['owl_carousel_data_info'] = mascot_core_prepare_owlcarousel_data_from_params( $settings );

		
		$settings['box_inline_css'] = mascot_core_get_inline_css( $this->pie_chart_box_css( $settings ) );

		$settings['settings'] = $settings;

		//Produce HTML version by using the parameters (filename, variation, folder name, parameters, shortcode_ob_start)
		$html = mascot_core_ecoife_wp_get_shortcode_template_part( 'forms', $settings['display_type'], 'wpcf-listing/tpl', $settings, true );
		
		echo $html;
	}
}
